#include "cave.h"
#include "cave_ym2151.h"

unsigned char CaveYM2151Registers[0x0100];
unsigned int CaveCurrentYM2151Register;

static short* pBuffer;
short* CaveYM2151Buffer[2];

static void AllocateBuffers()
{
	pBuffer = (short*)malloc(nBurnSoundLen * 2 * sizeof(short));

	CaveYM2151Buffer[0] = pBuffer;
	CaveYM2151Buffer[1] = pBuffer + nBurnSoundLen;
}

static void FreeBuffers()
{
	free(pBuffer);
}

int CaveYM2151Init(int nClockFrequency)
{
	YM2151Init(1, nClockFrequency, nBurnSoundRate);

	AllocateBuffers();
	return 0;
}

void CaveYM2151Exit()
{
	YM2151Shutdown();

	FreeBuffers();
}

void CaveYM2151Scan(int nAction)
{
	SCAN_VAR(CaveCurrentYM2151Register);
	SCAN_VAR(CaveYM2151Registers);

	if (nAction & 2) {
		for (int i = 0; i < 0x0100; i++) {
			YM2151WriteReg(0, i, CaveYM2151Registers[i]);
		}
	}
}
