#include "toaplan.h"
// Toaplan -- palette functions

unsigned char* ToaPalSrc;			// Pointer to input palette
unsigned int* ToaPalette;
int nToaPalLen;

unsigned char ToaRecalcPalette;		// Set to 1 to force recalculation of the entire palette (not needed now)

int ToaPalInit()
{
	return 0;
}

int ToaPalExit()
{
	return 0;
}

inline static unsigned int CalcCol(unsigned short nColour)
{
	int r, g, b;

	r = (nColour & 0x001F) << 3;	// Red
	r |= r >> 5;
	g = (nColour & 0x03E0) >> 2;  	// Green
	g |= g >> 5;
	b = (nColour & 0x7C00) >> 7;	// Blue
	b |= b >> 5;

	return BurnHighCol(r, g, b, 0);
}

int ToaPalUpdate()
{
	int i;
	unsigned short* ps;
	unsigned int* pd;

	for (i = 0, ps = (unsigned short*)ToaPalSrc, pd = ToaPalette; i < nToaPalLen; i++, ps += 1, pd++) {
		*pd = CalcCol(*ps);
	}
	return 0;
}

