#include "app.h"

static bool SkipComma(char** s)
{
	while (**s && **s != ',') {
		(*s)++;
	}

	if (**s == ',') {
		(*s)++;
	}
	
	if (**s) {
		return true;
	}

	return false;
}

static void ConfigParseFile(FILE* h)
{
	char szLine[1024];
	char* s;
	char* t;
	int nLen;

	CheatInfo* pCurrentCheat = NULL;

	while (1) {
		if (fgets(szLine, sizeof(szLine), h) == NULL) {
			break;
		}

		nLen = strlen(szLine);

		// Get rid of the linefeed at the end
		if (szLine[nLen - 1] == 0x0A) {
			szLine[nLen - 1] = 0;
			nLen--;
		}
		
		s = szLine;													// Start parsing

		if ((t = LabelCheck(s, "include")) != 0) {					// Include a file
			s = t;
			
			char szFilename[MAX_PATH] = "";
			
			// Read name of the cheat file
			char* szQuote = NULL;
			QuoteRead(&szQuote, NULL, s);

			sprintf(szFilename, "cheat\\%s.ini", szQuote);
			FILE* include = fopen(szFilename, "rt");

			if (include) {
				ConfigParseFile(include);
				fclose(include);
			}
			
			continue;
		}
		
		if ((t = LabelCheck(s, "cheat")) != 0) {					// Add new cheat
			s = t;
			
			// Link new node into the list
			CheatInfo* pPreviousCheat = pCurrentCheat;
			pCurrentCheat = (CheatInfo*)malloc(sizeof(CheatInfo));
			if (pCheatInfo == NULL) {
				pCheatInfo = pCurrentCheat;
			}
			
			memset(pCurrentCheat, 0, sizeof(CheatInfo));
			pCurrentCheat->pPrevious = pPreviousCheat;
			if (pPreviousCheat) {
				pPreviousCheat->pNext = pCurrentCheat;
			}

			// Fill in defaults
			pCurrentCheat->nType = 0;								// Default to cheat type 0 (apply each frame)
			pCurrentCheat->nStatus = -1;							// Disable cheat

			// Read cheat name
			char* szQuote = NULL;
			char* szEnd = NULL;
			QuoteRead(&szQuote, &szEnd, s);

			memcpy(pCurrentCheat->szCheatName, szQuote, QUOTE_MAX);

			continue;
		}

		if ((t = LabelCheck(s, "type")) != 0) {						// Cheat type
			if (pCurrentCheat) {
				s = t;

				// Set type
				pCurrentCheat->nType = strtol(s, NULL, 0);
			}
			
			continue;
		}
		
		if ((t = LabelCheck(s, "default")) != 0) {					// Default option
			if (pCurrentCheat) {
				s = t;

				// Set default option
				pCurrentCheat->nDefault = strtol(s, NULL, 0);
			}
			
			continue;
		}

		int n = strtol(s, &t, 0);
		if (t != s) {				   								// New option
			
			// Link a new Option structure to the cheat
			if (n < CHEAT_MAX_OPTIONS && pCurrentCheat) {
				s = t;

				// Read option name
				char* szQuote = NULL;
				char* szEnd = NULL;
				if (QuoteRead(&szQuote, &szEnd, s)) {
					break;
				}
				s = szEnd;

				if (pCurrentCheat->pOption[n] == NULL) {
					pCurrentCheat->pOption[n] = (CheatOption*)malloc(sizeof(CheatOption));
				}
				memset(pCurrentCheat->pOption[n], 0, sizeof(CheatOption));
			
				memcpy(pCurrentCheat->pOption[n]->szOptionName, szQuote, QUOTE_MAX);

				int nCurrentAddress = 0;
				while (nCurrentAddress < CHEAT_MAX_ADDRESS) {
					int nCPU = 0, nAddress = 0, nValue = 0;
					
					if (SkipComma(&s)) {
						nCPU = strtol(s, &t, 0);		// CPU number
						if (t == s) {
							break;
						}
						s = t;

						SkipComma(&s);
						nAddress = strtol(s, &t, 0);	// Address
						if (t == s) {
							break;
						}
						s = t;

						SkipComma(&s);
						nValue = strtol(s, &t, 0);		// Value
						if (t == s) {
							break;
						}
					} else {
						if (nCurrentAddress) {			// Only the first option is allowed no address
							break;
						}
					}
					
					pCurrentCheat->pOption[n]->AddressInfo[nCurrentAddress].nCPU = nCPU;
					pCurrentCheat->pOption[n]->AddressInfo[nCurrentAddress].nAddress = nAddress;
					pCurrentCheat->pOption[n]->AddressInfo[nCurrentAddress].nValue = nValue;
					nCurrentAddress++;
				}
			}

			continue;
		}

		// Line isn't (part of) a valid cheat, ignore it

	}
}

int ConfigCheatLoad()
{
	char szFilename[MAX_PATH] = "";
	FILE* h;
	
	sprintf(szFilename, "cheat\\%s.ini", BurnDrvText(0));
	h = fopen(szFilename, "rt");

	if (h == NULL) {
		return 1;
	}

	ConfigParseFile(h);

	fclose(h);

	if (pCheatInfo) {
		int nCurrentCheat = 0;
		while (CheatEnable(nCurrentCheat, -1) == 0) {
			nCurrentCheat++;
		}

		CheatUpdate();
	}
	
	return 0;
}


