
struct giConstant {
	unsigned char nConst;				// The constant value		
};

struct giSwitch {
	unsigned short nCode;				// The input code (for digital)
};

struct giJoyAxis {
	unsigned char nJoy;		   			// The joystick number
	unsigned char nAxis;	   			// The joystick axis number
};

//struct giMouseAxis {
//};

struct giSliderAxis {
	unsigned short nSlider[2];			// Keys to use for slider
};
	
struct giSlider {
	union {
		struct giJoyAxis JoyAxis;
		struct giSliderAxis SliderAxis;
	};
	short nSliderSpeed;					// speed with which keys move the slider
	short nSliderCenter;				// Speed the slider should center itself (high value = slow)
	int nSliderValue;					// Current position of the slider
};

struct giInput {
	unsigned char* pVal;				// Destination for the Input Value
	unsigned char nVal;					// The Input Value

	union {
		struct giConstant Constant;
		struct giSwitch Switch;
		struct giJoyAxis JoyAxis;
//		struct giMouseAxis MouseAxis;		
		struct giSlider Slider;
	};
};

struct giMacro {
	unsigned char nMode;				// 0 = Unused, 1 = used
	
	unsigned char* pVal[4];				// Destination for the Input Value
	unsigned char nVal[4];				// The Input Value
	unsigned char nInput[4];			// Which inputs are mapped

	struct giSwitch Switch;

	char szName[17];					// Maximum name length 16 chars
};

// struct giForce {
// }

struct GameInp {
	unsigned char nInput;				// PC side: 0=undefined, 1=constant value, 2=on/off switch, 3/4/5=joystick axis (analog), 6/7=slider
	unsigned char nType;				// game side: 0=binary (0,1), 1=analog (0x01-0xFF), 2=dip switch, 3=contstant		
	
	union {
		struct giInput Input;
//		struct giForce Force;
		struct giMacro Macro;
	};
};

