// Media module
#include "app.h"

int MediaInit()
{
	int nRet;

	nRet = ScrnInit();					// Init the Scrn Window
	if (nRet) {
		AppError("ScrnInit Failed",0);
		return 1;
	}
	ShowWindow(hScrnWnd, nAppShowCmd);	// Show the screen window
	nAppShowCmd = SW_NORMAL;			// Use normal show from now on

	DinpInit(hAppInst, hScrnWnd);		// Init DirectInput (can still use keyboard if it fails)
	nRet = InputInit();					// Init Input

	nAppVirtualFps = nBurnFPS;

	AudSoundInit();						// Init DSound (not critical if it fails)

	nBurnSoundRate = 0;					// Assume no sound
	pBurnSoundOut = NULL;
	if (bAudOkay) {
		nBurnSoundRate = nAudSampleRate;
		nBurnSoundLen = nAudSegLen;
	}

	return 0;
}

int MediaExit(bool bRestart)
{
	nBurnSoundRate = 0;					// Blank sound
	pBurnSoundOut = NULL;
	
	DestroyWindow(hInpsDlg);			// Make sure the Input Set dialog is exitted
	DestroyWindow(hInpdDlg);			// Make sure the Input Dialog is exitted

	VidExit();
	AudSoundExit();						// Exit Dsound
	InputExit();
	DinpExit();							// Exit DirectInput

	ScrnExit(bRestart);					// Exit the Scrn Window
	
	return 0;
}
