// Misc functions module
#include <math.h>
#include "app.h"

int bDoGamma = 0;
int bHardwareGammaOnly = 1;
float nGamma = 1.25;
const int nMaxRGB = 255;

static unsigned char GammaLUT[256];

// Set the current directory to be the application's directory
int AppDirectory()
{
	char *szCmd = NULL;
	char *szPath = NULL;
	int nLen = 0;
	char *pc1, *pc2;
	szCmd = GetCommandLine();

	// Find the end of the "c:\directory\program.exe" bit
	if (szCmd[0] == '\"') {						// Filneame is enclosed in quotes
		szCmd++;
		for (pc1 = szCmd; *pc1; pc1++) {
			if (*pc1 == '\"') break;			// Find the last "
		}
	} else {
		for (pc1 = szCmd; *pc1; pc1++) {
			if (*pc1 == ' ') break;				// Find the first space
		}
	}
	// Find the last \ or /
	for (pc2 = pc1; pc2 >= szCmd; pc2--) {
		if (*pc2 == '\\') break;
		if (*pc2 == '/') break;
	}

	// Copy the name of the executable into a variable
	nLen = pc1 - pc2 - 1;
	if (nLen > EXE_NAME_SIZE) {
		nLen = EXE_NAME_SIZE;
	}
	memcpy(&szAppExeName, pc2 + 1, nLen);
	szAppExeName[nLen] = 0;

	// strip .exe
	if ((pc1 = strchr(szAppExeName, '.')) != 0) {
		*pc1 = 0;
	}

	nLen = pc2 - szCmd;
	if (nLen <= 0) return 1;			// No path

	// Now copy the path into a new buffer
	szPath = (char *)malloc(nLen + 1);
	if (szPath == NULL) {
		return 1;
	}

	memcpy(szPath, szCmd, nLen);
	szPath[nLen] = 0;
	SetCurrentDirectory(szPath);		// Finally set the current directory to be the application's directory
	free(szPath);

	return 0;
}

static void MyRegCreateKeys(int nDepth, char* pNames[], HKEY* pResult)
{
	for (int i = 0; i < nDepth; i++) {
		pResult[i] = NULL;
		RegCreateKeyEx((i ? pResult[i - 1] : HKEY_CLASSES_ROOT), pNames[i], 0, "", 0, KEY_WRITE, NULL, &pResult[i], NULL);
	}
}

static void MyRegCloseKeys(int nDepth, HKEY* pKeys)
{
	for (int i = nDepth - 1; i >= 0; i--) {
		if (pKeys[i]) {
			RegCloseKey(pKeys[i]);
		}
	}
}

static void MyRegDeleteKeys(int nDepth, char* pNames[], HKEY* pKeys)
{
	for (int i = 0; i < nDepth - 1; i++) {
		pKeys[i] = NULL;
		RegOpenKeyEx((i ? pKeys[i - 1] : HKEY_CLASSES_ROOT), pNames[i], 0, 0, &pKeys[i]);
	}
	for (int i = nDepth - 1; i >= 0; i--) {
		RegDeleteKey((i ? pKeys[i - 1] : HKEY_CLASSES_ROOT), pNames[i]);
		if (i) {
			RegCloseKey(pKeys[i - 1]);
		}
	}
}

void RegisterExtensions(bool bCreateKeys)
{
	HKEY myKeys[4];

	char* myKeynames1[1] = {".fr"};
	char* myKeynames2[1] = {".fs"};
	char* myKeynames3[4] = {"FBAlpha", "shell", "open", "command"};
	char* myKeynames4[2] = {"FBAlpha", "DefaultIcon"};
	char myKeyValue[MAX_PATH + 32] = "";

	if (bCreateKeys) {
		char* szCmd;
		int nCmdSize;
		char szExename[MAX_PATH] = "";

		szCmd = GetCommandLine();
		if (szCmd[0] == '\"') {
			int nLen = strlen(szCmd);
			nCmdSize = 1;
			while (szCmd[nCmdSize] != '\"' && nCmdSize < nLen) {
				nCmdSize++;
			}
			if (nCmdSize == nLen) {
				szExename[0] = 0;
			} else {
				nCmdSize++;
				strncpy(szExename, szCmd + 1, nCmdSize - 2);
				szExename[nCmdSize - 2] = 0;
			}
		} else {
			int nLen = strlen(szCmd);
			nCmdSize = 0;
			while (szCmd[nCmdSize] != ' ' && nCmdSize < nLen) {
				nCmdSize++;
			}
			strncpy(szExename, szCmd, nCmdSize);
			szExename[nCmdSize] = 0;
		}

		MyRegCreateKeys(1, myKeynames1, myKeys);
		sprintf(myKeyValue, "FBAlpha");
		RegSetValueEx(myKeys[0], NULL, 0, REG_SZ, (BYTE*)myKeyValue, strlen(myKeyValue) + 1);
		MyRegCloseKeys(2, myKeys);

		MyRegCreateKeys(1, myKeynames2, myKeys);
		sprintf(myKeyValue, "FBAlpha");
		RegSetValueEx(myKeys[0], NULL, 0, REG_SZ, (BYTE*)myKeyValue, strlen(myKeyValue) + 1);
		MyRegCloseKeys(2, myKeys);

		MyRegCreateKeys(4, myKeynames3, myKeys);
		sprintf(myKeyValue, "\"%s\" \"%%1\" -w", szExename);
		RegSetValueEx(myKeys[3], NULL, 0, REG_SZ, (BYTE*)myKeyValue, strlen(myKeyValue) + 1);
		sprintf(myKeyValue, "FB Alpha file");
		RegSetValueEx(myKeys[0], NULL, 0, REG_SZ, (BYTE*)myKeyValue, strlen(myKeyValue) + 1);
		MyRegCloseKeys(4, myKeys);

		MyRegCreateKeys(2, myKeynames4, myKeys);
		sprintf(myKeyValue, "\"%s\", 0", szExename);
		RegSetValueEx(myKeys[1], NULL, 0, REG_SZ, (BYTE*)myKeyValue, strlen(myKeyValue) + 1);
		MyRegCloseKeys(2, myKeys);
	} else {
		MyRegDeleteKeys(2, myKeynames4, myKeys);
		MyRegDeleteKeys(4, myKeynames3, myKeys);
		MyRegDeleteKeys(1, myKeynames2, myKeys);
		MyRegDeleteKeys(1, myKeynames1, myKeys);
	}

	return;
}

// Get the position of the client area of a window on the screen
int GetClientScreenRect(HWND hWnd, RECT *pRect)
{
	POINT Corner = {0, 0};
	GetClientRect(hWnd, pRect);
	Corner.x = 0;
	Corner.y = 0;
	ClientToScreen(hWnd, &Corner);
	pRect->left += Corner.x;
	pRect->right += Corner.x;
	pRect->top += Corner.y;
	pRect->bottom += Corner.y;
	
	return 0;
}

void ComputeGammaLUT()
{
	for (int i = 0; i < 256; i++) {
		GammaLUT[i] = (unsigned char)((double)nMaxRGB * pow((i / 255.0), nGamma));
	}
}

// Standard callbacks for 16/24/32 bit color:
static unsigned int HighCol15(int r, int g, int b, int  /* i */)
{
	unsigned int t;
	t =(r<<7)&0x7c00; // 0rrr rr00 0000 0000
	t|=(g<<2)&0x03e0; // 0000 00gg ggg0 0000
	t|=(b>>3)&0x001f; // 0000 0000 000b bbbb
	return t;
}

static unsigned int HighCol16(int r, int g, int b, int /* i */)
{
	unsigned int t;
	t =(r<<8)&0xf800; // rrrr r000 0000 0000
	t|=(g<<3)&0x07e0; // 0000 0ggg ggg0 0000
	t|=(b>>3)&0x001f; // 0000 0000 000b bbbb
	return t;
}

// 24-bit/32-bit
static unsigned int HighCol24(int r, int g, int b, int  /* i */)
{
	unsigned int t;
	t =(r<<16)&0xff0000;
	t|=(g<<8 )&0x00ff00;
	t|=(b    )&0x0000ff;

	return t;
}

static unsigned int HighCol15Gamma(int r, int g, int b, int  /* i */)
{
	unsigned int t;
	t = (GammaLUT[r] << 7) & 0x7C00; // 0rrr rr00 0000 0000
	t |= (GammaLUT[g] << 2) & 0x03E0; // 0000 00gg ggg0 0000
	t |= (GammaLUT[b] >> 3) & 0x001F; // 0000 0000 000b bbbb
	return t;
}

static unsigned int HighCol16Gamma(int r, int g ,int b, int  /* i */)
{
	unsigned int t;
	t = (GammaLUT[r] << 8) & 0xF800; // rrrr r000 0000 0000
	t |= (GammaLUT[g] << 3) & 0x07E0; // 0000 0ggg ggg0 0000
	t |= (GammaLUT[b] >> 3) & 0x001F; // 0000 0000 000b bbbb
	return t;
}

// 24-bit/32-bit
static unsigned int HighCol24Gamma(int r, int g, int b, int  /* i */)
{
	unsigned int t;
	t = (GammaLUT[r] << 16);
	t |= (GammaLUT[g] << 8);
	t |= GammaLUT[b];

	return t;
}

int SetBurnHighCol(int nDepth)
{
	if (bDoGamma && ((nVidFullscreen && !bVidUseHardwareGamma) || (!nVidFullscreen && !bHardwareGammaOnly))) {
		if (nDepth == 15) {
			BurnHighCol = HighCol15Gamma;
			return 0;
		}
		if (nDepth == 16) {
			BurnHighCol = HighCol16Gamma;
			return 0;
		}
		BurnHighCol = HighCol24Gamma;
	} else {
		if (nDepth == 15) {
			BurnHighCol = HighCol15;
			return 0;
		}
		if (nDepth == 16) {
			BurnHighCol = HighCol16;
			return 0;
		}
		BurnHighCol = HighCol24;
	}
	return 0;
}

// Put a window in the middle of another window
int WndInMid(HWND hMid, HWND hBase)
{
	RECT MidRect = {0, 0, 0, 0};
	int mw = 0, mh = 0;
	RECT BaseRect = {0, 0, 0, 0};
	int bx = 0, by = 0;
	
	// Find the height and width of the Mid window
	GetWindowRect(hMid, &MidRect);
	mw = MidRect.right - MidRect.left;
	mh = MidRect.bottom - MidRect.top;

	// Find the center of the Base window
	GetWindowRect(hBase, &BaseRect);
	if (hBase == hScrnWnd) {
		// For the main window, center in the client area.
		BaseRect.left += GetSystemMetrics(SM_CXSIZEFRAME);
		BaseRect.right -= GetSystemMetrics(SM_CXSIZEFRAME);
		BaseRect.top += GetSystemMetrics(SM_CYSIZEFRAME) + GetSystemMetrics(SM_CYCAPTION) + nMenuHeight;
		BaseRect.bottom -= GetSystemMetrics(SM_CYSIZEFRAME);
	}
	bx = BaseRect.left + BaseRect.right;
	bx >>= 1;
	by = BaseRect.top + BaseRect.bottom;
	by >>= 1;

	// Center the window
	SetWindowPos(hMid, NULL, bx - (mw >> 1), by - (mh >> 1), 0, 0, SWP_NOSIZE | SWP_NOZORDER);
	
	return 0;
}

static char szKeyName[0x54][16] =
{
	// 0x00:
	"", "Escape", "1", "2", "3", "4", "5", "6", "7", "8", "9", "0", "Minus", "Equals", "Backspace",
	// 0x0f
	"Tab", "Q", "W", "E", "R", "T", "Y", "U", "I", "O", "P", "[", "]", "Enter",
	// 0x1d
	"Left Ctrl", "A", "S", "D", "F", "G", "H", "J", "K", "L", "Semicolon", "Apostrophe", "Accent Grave",
	// 0x2a
	"Left Shift", "Backslash", "Z", "X", "C", "V", "B", "N", "M", "Comma", "Period", "Slash", "Right Shift",
	// 0x37
	"NumPad *", "Left Alt", "Space", "Caps Lock",
	// 0x3b
	"F1", "F2", "F3", "F4", "F5", "F6", "F7", "F8", "F9", "F10",
	// 0x45
	"NumLock"," ScrollLock",
	"NumPad 7", "NumPad 8", "NumPad 9", "NumPad Minus",
	"NumPad 4", "NumPad 5", "NumPad 6", "NumPad Plus",
	"NumPad 1", "NumPad 2", "NumPad 3",
	"NumPad 0", "NumPad Period"
};

// Print a nice name for input code c
char *InputCodeDesc(int c)
{
	static char szString[64];
	char* szName = "";
	if (c >= 0x4000) {
		int nJoy = (c >> 8) & 0x3F;
		int nCode = c & 0xFF;
		if (nCode >= 0x80) {
			sprintf(szString, "Joy %d Button %d", nJoy, nCode & 0x7F);
			return szString;
		}
		if (nCode < 0x10) {
			char szAxis[8][16] = {"X", "Y", "Z", "rX", "rY", "rZ", "s0", "s1"};
			char szDir[6][16] = {"negative", "positive", "Left", "Right", "Up", "Down"};
			if (nCode < 4) {
				sprintf(szString, "Joy %d %s (%s %s)", nJoy, szDir[nCode + 2], szAxis[nCode >> 1], szDir[nCode & 1]);
			} else {
				sprintf(szString, "Joy %d %s %s", nJoy, szAxis[nCode >> 1], szDir[nCode & 1]);
			}
			return szString;
		}	
		if (nCode < 0x20) {
			char szDir[4][16] = {"Left", "Right", "Up", "Down"};
			sprintf(szString, "Joy %d POV-hat %d %s", nJoy, (nCode & 0x0F) >> 2, szDir[nCode & 3]);
			return szString;
		}
	}

	// Try and get a name for the key code
	if (c < 0x54) {										// Get from the table of first few keys
		szName = szKeyName[c];
	} else {
		switch (c) {
			case 0x56:
				szName = "Back-Slash";
				break;
			case 0x57:
				szName = "F11";
				break;
			case 0x58:
				szName = "F12";
				break;
			case 0x9C:
				szName = "NumPad Enter";
				break;
			case 0x9D:
				szName = "Right Ctrl";
				break;
			case 0xB5:
				szName = "NumPad divide";
				break;
			case 0xB7:
				szName = "PrintScrn";
				break;
			case 0xB8:
				szName = "Right Alt / AltGr";
				break;
			case 0xC5:
				szName = "Pause";
				break;
			case 0xC7:
				szName = "Home";
				break;
			case 0xC8:
				szName = "Up Arrow";
				break;
			case 0xC9:
				szName = "PgUp";
				break;
			case 0xCB:
				szName = "Left Arrow";
				break;
			case 0xCD:
				szName = "Right Arrow";
				break;
			case 0xCF:
				szName = "End";
				break;
			case 0xD0:
				szName = "Down Arrow";
				break;
			case 0xD1:
				szName = "PgDn";
				break;
			case 0xD2:
				szName = "Insert";
				break;
			case 0xD3:
				szName = "Delete";
				break;
			case 0xDB:
				szName = "Left Win";
				break;
			case 0xDC:
				szName = "Right Win";
				break;
			case 0xDD:
				szName = "AppMenu";
				break;
		}
	}

	if (szName[0]) {
		sprintf(szString, "%s", szName);
	} else {
		sprintf(szString, "Key 0x%.2x", c);
	}
	
	return szString;
}
